/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the TokenExchangeRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &TokenExchangeRequest{}

// TokenExchangeRequest struct for TokenExchangeRequest
type TokenExchangeRequest struct {
	RegistrationId        NullableString `json:"registrationId,omitempty"`
	AllowedRegistrationId NullableString `json:"allowedRegistrationId,omitempty"`
	Comment               NullableString `json:"comment,omitempty"`
}

// NewTokenExchangeRequest instantiates a new TokenExchangeRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewTokenExchangeRequest() *TokenExchangeRequest {
	this := TokenExchangeRequest{}
	return &this
}

// NewTokenExchangeRequestWithDefaults instantiates a new TokenExchangeRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewTokenExchangeRequestWithDefaults() *TokenExchangeRequest {
	this := TokenExchangeRequest{}
	return &this
}

// GetRegistrationId returns the RegistrationId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *TokenExchangeRequest) GetRegistrationId() string {
	if o == nil || IsNil(o.RegistrationId.Get()) {
		var ret string
		return ret
	}
	return *o.RegistrationId.Get()
}

// GetRegistrationIdOk returns a tuple with the RegistrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *TokenExchangeRequest) GetRegistrationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.RegistrationId.Get(), o.RegistrationId.IsSet()
}

// HasRegistrationId returns a boolean if a field has been set.
func (o *TokenExchangeRequest) HasRegistrationId() bool {
	if o != nil && o.RegistrationId.IsSet() {
		return true
	}

	return false
}

// SetRegistrationId gets a reference to the given NullableString and assigns it to the RegistrationId field.
func (o *TokenExchangeRequest) SetRegistrationId(v string) {
	o.RegistrationId.Set(&v)
}

// SetRegistrationIdNil sets the value for RegistrationId to be an explicit nil
func (o *TokenExchangeRequest) SetRegistrationIdNil() {
	o.RegistrationId.Set(nil)
}

// UnsetRegistrationId ensures that no value is present for RegistrationId, not even an explicit nil
func (o *TokenExchangeRequest) UnsetRegistrationId() {
	o.RegistrationId.Unset()
}

// GetAllowedRegistrationId returns the AllowedRegistrationId field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *TokenExchangeRequest) GetAllowedRegistrationId() string {
	if o == nil || IsNil(o.AllowedRegistrationId.Get()) {
		var ret string
		return ret
	}
	return *o.AllowedRegistrationId.Get()
}

// GetAllowedRegistrationIdOk returns a tuple with the AllowedRegistrationId field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *TokenExchangeRequest) GetAllowedRegistrationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.AllowedRegistrationId.Get(), o.AllowedRegistrationId.IsSet()
}

// HasAllowedRegistrationId returns a boolean if a field has been set.
func (o *TokenExchangeRequest) HasAllowedRegistrationId() bool {
	if o != nil && o.AllowedRegistrationId.IsSet() {
		return true
	}

	return false
}

// SetAllowedRegistrationId gets a reference to the given NullableString and assigns it to the AllowedRegistrationId field.
func (o *TokenExchangeRequest) SetAllowedRegistrationId(v string) {
	o.AllowedRegistrationId.Set(&v)
}

// SetAllowedRegistrationIdNil sets the value for AllowedRegistrationId to be an explicit nil
func (o *TokenExchangeRequest) SetAllowedRegistrationIdNil() {
	o.AllowedRegistrationId.Set(nil)
}

// UnsetAllowedRegistrationId ensures that no value is present for AllowedRegistrationId, not even an explicit nil
func (o *TokenExchangeRequest) UnsetAllowedRegistrationId() {
	o.AllowedRegistrationId.Unset()
}

// GetComment returns the Comment field value if set, zero value otherwise (both if not set or set to explicit null).
func (o *TokenExchangeRequest) GetComment() string {
	if o == nil || IsNil(o.Comment.Get()) {
		var ret string
		return ret
	}
	return *o.Comment.Get()
}

// GetCommentOk returns a tuple with the Comment field value if set, nil otherwise
// and a boolean to check if the value has been set.
// NOTE: If the value is an explicit nil, `nil, true` will be returned
func (o *TokenExchangeRequest) GetCommentOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Comment.Get(), o.Comment.IsSet()
}

// HasComment returns a boolean if a field has been set.
func (o *TokenExchangeRequest) HasComment() bool {
	if o != nil && o.Comment.IsSet() {
		return true
	}

	return false
}

// SetComment gets a reference to the given NullableString and assigns it to the Comment field.
func (o *TokenExchangeRequest) SetComment(v string) {
	o.Comment.Set(&v)
}

// SetCommentNil sets the value for Comment to be an explicit nil
func (o *TokenExchangeRequest) SetCommentNil() {
	o.Comment.Set(nil)
}

// UnsetComment ensures that no value is present for Comment, not even an explicit nil
func (o *TokenExchangeRequest) UnsetComment() {
	o.Comment.Unset()
}

func (o TokenExchangeRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o TokenExchangeRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if o.RegistrationId.IsSet() {
		toSerialize["registrationId"] = o.RegistrationId.Get()
	}
	if o.AllowedRegistrationId.IsSet() {
		toSerialize["allowedRegistrationId"] = o.AllowedRegistrationId.Get()
	}
	if o.Comment.IsSet() {
		toSerialize["comment"] = o.Comment.Get()
	}
	return toSerialize, nil
}

type NullableTokenExchangeRequest struct {
	value *TokenExchangeRequest
	isSet bool
}

func (v NullableTokenExchangeRequest) Get() *TokenExchangeRequest {
	return v.value
}

func (v *NullableTokenExchangeRequest) Set(val *TokenExchangeRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableTokenExchangeRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableTokenExchangeRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableTokenExchangeRequest(val *TokenExchangeRequest) *NullableTokenExchangeRequest {
	return &NullableTokenExchangeRequest{value: val, isSet: true}
}

func (v NullableTokenExchangeRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableTokenExchangeRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
